Subject: Re: [PATCH] IPv6: only modify checksum for UDP

From: Al Viro <[email-masked]>
Date: Tue, 14 Nov 2006 01:52:47 +0000

On Mon, Nov 13, 2006 at 05:44:12PM -0800, David Stevens wrote:
>         That's actually what I was suggesting. In 1's-complement,
> ~0 == -0 which is still 0, so barring any special case (like UDP's
> "0 means no checksum" rule), it should be equally valid for a
> packet to have 0 or ~0 as the checksum (with otherwise identical
> data)-- they are both correct, and equal to each other. That
> extra 1's-complement 0 is, of course, why UDP can have the
> special case of remapping 0->~0.
>         Since the patch was for output-side, it doesn't matter
> whether you remap 0 to ~0 or not (except for the special case),
> but a receiver technically should allow either.

Could you please take a break from your Richard B. Johnson imitations
and read the fscking RFC?